
package de.ivu.elect.presentation.email;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.email.boundary.EmailLayoutConversationStore;
import de.ivu.elect.business.email.boundary.EmailLayoutExtendedDAO;
import de.ivu.elect.business.email.boundary.EmailLayoutEdit;
import de.ivu.elect.business.email.entity.EmailLayout;
import de.ivu.elect.business.email.entity.EmailLayoutMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractEmailLayoutEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractEmailLayoutEditNoScopeView.VIEW_ID, useCase = UseCasePermission.EMAIL_LAYOUT_EDIT)
public abstract class AbstractEmailLayoutEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<EmailLayout>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailLayoutEditView";

  public static final String VIEW_ID = "/email/email-layout-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/email/email-layout-search.xhtml";

  @Inject
  protected transient EmailLayoutExtendedDAO extendedDAO;

  @Inject
  protected transient EmailLayoutEdit edit;

  @Inject
  @ConversationGroup(EmailLayoutConversationStore.class)
  protected transient EmailLayoutConversationStore conversationStore;

  @Inject
  protected transient EmailLayoutMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient EmailLayoutEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public EmailLayout getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(EmailLayout entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_LAYOUT_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(EmailLayout entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_LAYOUT_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.EMAIL_LAYOUT_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.EMAIL_LAYOUT_EDIT)
  @Override
  public String save() {
    EmailLayout entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(EmailLayout entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    EmailLayout entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(EmailLayout entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.EMAIL_LAYOUT_EDIT);
  }
  
  @Redirect
  public String edit(EmailLayout entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class EmailLayoutEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<EmailLayout,   de.ivu.elect.business.email.entity.EmailLayoutPK  > {

    private static final long serialVersionUID = 1L;
  }
}
